"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var async_1 = require('@angular/forms/src/facade/async');
var ValidateDirective = (function () {
    function ValidateDirective(el, renderer, formGroup, ngForm) {
        this.el = el;
        this.renderer = renderer;
        this.formGroup = formGroup;
        this.ngForm = ngForm;
        this.showErrors = new core_1.EventEmitter();
        this.form = this.formGroup || this.ngForm;
    }
    ValidateDirective.prototype.ngOnInit = function () {
        this.renderer.setElementAttribute(this.el.nativeElement, 'novalidate', 'novalidate');
        var eventEmitter = this.showErrors;
        this.form.onSubmit = function () {
            this._submitted = true;
            if (this.valid) {
                async_1.ObservableWrapper.callEmit(this.ngSubmit, null);
            }
            else {
                eventEmitter.emit(this.valid);
            }
            return false;
        };
    };
    ValidateDirective.prototype.addErrors = function (fieldName, errors) {
        this.form.form.controls[fieldName].setErrors(errors);
        this.showErrors.emit(false);
    };
    ValidateDirective = __decorate([
        core_1.Directive({
            selector: '[validate]',
            exportAs: 'validate'
        }),
        __param(2, core_1.Optional()),
        __param(3, core_1.Optional()), 
        __metadata('design:paramtypes', [core_1.ElementRef, core_1.Renderer, forms_1.FormGroupDirective, forms_1.NgForm])
    ], ValidateDirective);
    return ValidateDirective;
}());
exports.ValidateDirective = ValidateDirective;
//# sourceMappingURL=validate.directive.js.map