"use strict";
var lang_1 = require('@angular/forms/src/facade/lang');
var forms_1 = require('@angular/forms');
var CustomValidators = (function () {
    function CustomValidators() {
    }
    /**
     * Validator that requires controls to be a valid email.
     */
    CustomValidators.email = function (control) {
        if (lang_1.isPresent(forms_1.Validators.required(control))) {
            return null;
        }
        // See: https://html.spec.whatwg.org/multipage/forms.html#valid-e-mail-address
        var pattern = /^[a-zA-Z0-9.!#$%&'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/;
        return pattern.test(control.value) ? null : { 'email': true };
    };
    CustomValidators.min = function (min) {
        return function (control) {
            if (lang_1.isPresent(forms_1.Validators.required(control))) {
                return null;
            }
            var v = Number(control.value);
            return v < min ? { 'min': { 'requiredMin': min, 'actualMin': v } } : null;
        };
    };
    CustomValidators.max = function (max) {
        return function (control) {
            if (lang_1.isPresent(forms_1.Validators.required(control))) {
                return null;
            }
            var v = Number(control.value);
            return v > max ? { 'max': { 'requiredMax': max, 'actualMax': v } } : null;
        };
    };
    return CustomValidators;
}());
exports.CustomValidators = CustomValidators;
;
//# sourceMappingURL=custom-validators.service.js.map